org.apache.sysds.runtime.compress.estim

## Class CompressedSizeEstimator

- java.lang.Object
- - org.apache.sysds.runtime.compress.estim.CompressedSizeEstimator

- Direct Known Subclasses:
    CompressedSizeEstimatorExact, CompressedSizeEstimatorSample

      public abstract class CompressedSizeEstimator
      extends Object

  Main abstract class for estimating size of compressions on columns.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `CompressedSizeInfo` | `computeCompressedSizeInfos(int k)` Multi threaded version of extracting Compression Size info
    `CompressedSizeInfoColGroup` | `estimateCompressedColGroupSize()` Method used for compressing into one type of colGroup
    `EstimationFactors` | `estimateCompressedColGroupSize(ABitmap ubm)` Method used to extract the CompressedSizeEstimationFactors from an constructed UncompressedBitmap.
    `abstract CompressedSizeInfoColGroup` | `estimateCompressedColGroupSize(int[] colIndexes)` Abstract method for extracting Compressed Size Info of specified columns, together in a single ColGroup

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### computeCompressedSizeInfos

          public CompressedSizeInfo computeCompressedSizeInfos(int k)

      Multi threaded version of extracting Compression Size info
      Parameters:
        `k` - The concurrency degree.
      Returns:
        The Compression Size info of each Column compressed isolated.

    - #### estimateCompressedColGroupSize

          public CompressedSizeInfoColGroup estimateCompressedColGroupSize()

      Method used for compressing into one type of colGroup
      Returns:
        CompressedSizeInfo on a compressed colGroup compressing the entire matrix into a single colGroup type.

    - #### estimateCompressedColGroupSize

          public abstract CompressedSizeInfoColGroup estimateCompressedColGroupSize(int[] colIndexes)

      Abstract method for extracting Compressed Size Info of specified columns, together in a single ColGroup
      Parameters:
        `colIndexes` - The Colums to group together inside a ColGroup
      Returns:
        The CompressedSizeInformation associated with the selected ColGroups.

    - #### estimateCompressedColGroupSize

          public EstimationFactors estimateCompressedColGroupSize(ABitmap ubm)

      Method used to extract the CompressedSizeEstimationFactors from an constructed UncompressedBitmap. Note this method works both for the sample based estimator and the exact estimator, since the bitmap, can be extracted from a sample or from the entire dataset.
      Parameters:
        `ubm` - the UncompressedBitmap, either extracted from a sample or from the entier dataset
      Returns:
        The size factors estimated from the Bit Map.

Copyright © 2020 The Apache Software Foundation. All rights reserved.